// RobotView.h : interface of the CRobotView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROBOTVIEW_H__A88383EC_F651_11D3_A2DE_00105AC6F929__INCLUDED_)
#define AFX_ROBOTVIEW_H__A88383EC_F651_11D3_A2DE_00105AC6F929__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMoveDlg;
class CStatementDlg;

class CRobotView : public CView
{
protected: // create from serialization only
	CRobotView();
	DECLARE_DYNCREATE(CRobotView)

// Attributes
public:
	CRobotDoc* GetDocument();
	CMoveDlg *moveDlg;
	CStatementDlg *stateDlg;

// Operations
public:
	void DrawGrid();
	void DrawWall();
	void DrawRobotAndExit();
	void ExecuteCmd(WPARAM w, LPARAM l);
	void OnStateProcess(WPARAM w, LPARAM l);


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRobotView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CRobotView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CRobotView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnGridsize();
	afx_msg void OnRobotpos();
	afx_msg void OnRobotcmd();
	afx_msg void OnDestroy();
	afx_msg void OnExitpos();
	afx_msg void OnStatement();
	afx_msg void OnRun();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in RobotView.cpp
inline CRobotDoc* CRobotView::GetDocument()
   { return (CRobotDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ROBOTVIEW_H__A88383EC_F651_11D3_A2DE_00105AC6F929__INCLUDED_)
