// StatementDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Robot.h"
#include "StatementDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStatementDlg dialog

CStatementDlg::CStatementDlg(CView *theView)
{
	this->theView = theView;
	Create(CStatementDlg::IDD);
	m_edit = _T("");
}

CStatementDlg::CStatementDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStatementDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStatementDlg)
	m_edit = _T("");
	m_randir = FALSE;
	//}}AFX_DATA_INIT
}


void CStatementDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStatementDlg)
	DDX_Control(pDX, IDC_LIST, m_list);
	DDX_Text(pDX, IDC_EDIT, m_edit);
	DDX_Check(pDX, IDC_RANDIR, m_randir);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStatementDlg, CDialog)
	//{{AFX_MSG_MAP(CStatementDlg)
	ON_BN_CLICKED(IDC_SET, OnSet)
	ON_BN_CLICKED(ID_CLOSE, OnClose)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_RUN, OnRun)
	ON_BN_CLICKED(IDC_TEST, OnTest)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_BN_CLICKED(IDC_SETPOS, OnSetpos)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStatementDlg message handlers

BOOL CStatementDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	idx = 0;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CStatementDlg::OnSet() 
{
	int i;

	UpdateData(TRUE);

	if (m_list.GetCurSel() == LB_ERR)
		return;

	m_edit.MakeUpper();

	states[m_list.GetCurSel()].Format("%02d: ", m_list.GetCurSel());
	states[m_list.GetCurSel()] += m_edit;
	m_edit.Empty();

	m_list.ResetContent();

	for (i=0; i<50; i++)
		m_list.AddString(states[i]);

	UpdateData(FALSE);

	NextIndicator();
}

void CStatementDlg::Retrieve()
{
	int i;

	m_list.ResetContent();

	for (i=0; i<50; i++)
		m_list.AddString(states[i]);

	ShowIndicator();
}

void CStatementDlg::OnClose() 
{
	ShowWindow(SW_HIDE);	
}

void CStatementDlg::OnStop() 
{
	theView->SendMessage(WM_STATEMENT, 1, 0);
}

void CStatementDlg::OnRun() 
{
	theView->SendMessage(WM_STATEMENT, 2, 0);
}

void CStatementDlg::OnTest() 
{
	theView->SendMessage(WM_STATEMENT, 3, 0);	
}

void CStatementDlg::SetIndicator(int i)
{
	idx = i;
	m_list.SetCurSel(idx);
}

void CStatementDlg::NextIndicator()
{
	idx++;

	if (idx == 50)
		idx=0;

	m_list.SetCurSel(idx);
}

void CStatementDlg::ShowIndicator()
{
	m_list.SetCurSel(idx);
}

void CStatementDlg::ResetIndicator()
{
	idx = 0;
	m_list.SetCurSel(idx);
}

BOOL CStatementDlg::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_RETURN)
	{
		OnSet();
		theView->SendMessage(WM_STATEMENT, 0, 0);
		pMsg->message = 0;
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}

BOOL CStatementDlg::IsRanDir() 
{
	UpdateData(TRUE);
	
	return m_randir;
}

void CStatementDlg::OnReset() 
{
	theView->SendMessage(WM_STATEMENT, 4, 0);	
}

void CStatementDlg::OnSetpos() 
{
	idx = m_list.GetCurSel();	
}
